import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.net.*;
import java.util.*;
import javax.xml.transform.*;
import javax.xml.transform.stream.*;

public class ApplyXSLT extends HttpServlet {

    public void doGet (HttpServletRequest request, HttpServletResponse response)
           throws ServletException, IOException, java.net.MalformedURLException
    {
        response.setContentType("text/html");
        PrintWriter out = response.getWriter();
        try {
            if (request.getParameter("show") != null) {
                RequestDispatcher rd = getServletContext().getRequestDispatcher("/showXSLT");
                rd.forward(request,response);
            }
            String source = request.getParameter("source");
            int ix = source.lastIndexOf('/');
            String xmlDoc = source.substring(0,ix);
            String xslDoc = source.substring(ix);
            TransformerFactory factory = TransformerFactory.newInstance();

            ServletContext context = getServletContext();

            Source xsl = new StreamSource(context.getResourceAsStream(xslDoc));
            Transformer transformer = factory.newTransformer(xsl);
            transformer.setOutputProperty(OutputKeys.METHOD,"html");

            out.println("<H2>Transformed Document</H2>");
            Source xml = new StreamSource(context.getResourceAsStream(xmlDoc));
            transformer.transform(xml, new StreamResult(out));
            
        }
        catch (Exception ex) {
            out.println(ex);
            ex.printStackTrace(out);
        }
        out.close();
    }


}
