import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;

public class ShowXSLT extends HttpServlet {

    public void doGet (HttpServletRequest request, HttpServletResponse response)
           throws ServletException, IOException, java.net.MalformedURLException
    {
        response.setContentType("text/html");
        PrintWriter out = response.getWriter();
        try {
            if (request.getParameter("apply") != null) {
                RequestDispatcher rd = getServletContext().getRequestDispatcher("/applyXSLT");
                rd.forward(request,response);
            }
            String source = request.getParameter("source");
            int ix = source.lastIndexOf('/');
            String xmlDoc = source.substring(0,ix);
            String xslDoc = source.substring(ix);
            out.println("<HTML><BODY>");
            out.println("<P><A HREF='xsltForm.jsp'>Back to xsltForm</A></P>");
            showResource("XSL Stylesheet", xslDoc, out);
            showResource("XML Source", xmlDoc, out);
            out.println("</BODY></HTML>");
        }
        catch (Exception ex) {
            out.println(ex);
            ex.printStackTrace(out);
        }
        out.close();
    }

    private void showResource(String heading, String name, PrintWriter out) throws IOException {
        out.println("<H2>"+heading+"</H2>");
        BufferedReader in = new BufferedReader(new InputStreamReader(getServletContext().getResourceAsStream(name)));
        HtmlWriter bout = new HtmlWriter(out);
        char[] buffer = new char[1024];
        int len=0;
        while ((len=in.read(buffer,0,buffer.length))>=0) {
            bout.write(buffer,0,len);
        }
        out.print("<P>");
        in.close();
    }
}

class HtmlWriter
{
    Writer out;
    int column=0;
    
    public HtmlWriter (Writer out) {
        this.out = out;
    }

    void close() throws IOException {
        out.close();
    }
    
    void flush() throws IOException {
        out.flush();
    }
    
    void write(char[] cbuf, int off, int len) throws IOException {
        int start = off;
        int end = off+len;
        for (int i=off; i<end; i++) {
            String replace = null;
            switch (cbuf[i]) {
                case '\t': replace="&nbsp;"; break;
                case ' ':  replace="&nbsp;"; break;
                case '<':  replace="&lt;";   break;
                case '>':  replace="&gt;";   break;
                case '&':  replace="&amp;";  break;
                case '\'': replace="&apos;"; break;
                case '"':  replace="&quot;"; break;
                case '\n': replace="<BR>\n"; break;
                default: break;
            }
            if (replace != null) {
                out.write (cbuf, start, i-start);
                start = i+1;
                out.write (replace);
            }
        }
        if (start < end)
            out.write (cbuf,start,len-start);
    }
           

}
