import java.io.*;
import javax.xml.transform.*;
import javax.xml.transform.stream.*;

public class Transform  {

    public static void main(String[] args) {
        if (args.length!=2 && args.length!=3) {
            System.err.println("Usage: Transform stylesheet source [ destination ]");
            System.exit(1);
        }
        try {
            TransformerFactory factory = TransformerFactory.newInstance();

            Source xsl = new StreamSource(new FileReader(args[0]));
            Transformer transformer = factory.newTransformer(xsl);
            transformer.setOutputProperty(OutputKeys.METHOD,"html");

            Source xml = new StreamSource(new FileReader(args[1]));

            PrintStream outs = System.out;
            if (args.length==3)
                outs = new PrintStream(new FileOutputStream(args[2]));
            transformer.transform(xml, new StreamResult(outs));
            if (outs != System.out)
                outs.close();
        }
        catch (Exception ex) {
            System.err.println(ex);
            ex.printStackTrace(System.err);
        }
    }

}
