package agency;

import java.sql.*;
import javax.sql.*;
import javax.naming.*;

public class DirectDAOImpl
{
  private DataSource dataSource;
  private Connection connection;

  protected DirectDAOImpl(String jndiName) throws SQLException, NamingException
  {
    InitialContext ic = new InitialContext();
    dataSource = (DataSource)ic.lookup(jndiName);
  }

  protected Connection acquireConnection() throws SQLException
  {
    if (connection == null)
    {
      connection = dataSource.getConnection();
    }
    return connection;
  }

  protected void releaseConnection ()
  {
    if (connection != null)
    {
        try
        {
            connection.close();
	    connection = null;
        }
        catch (SQLException e) {}
    }
  }

  protected void releaseResultSet(ResultSet rslt)
  {
    if (rslt != null)
    {
        try
        {
            rslt.close();
        }
        catch (SQLException e) {}
    }
  }

  protected void releasePreparedStatement(PreparedStatement stmt)
  {
    if (stmt != null)
    {
        try {
            stmt.close();
        }
        catch (SQLException e) {}
    }
  }
}
