import java.math.*;
import java.util.*;
import javax.resource.cci.*;
import javax.resource.*;
import javax.naming.*;

public class MyEisBean
{
    public int countCustomers() throws MyEisException {
        Connection con =  null;
        try {
            Context ic = new InitialContext();
            ConnectionFactory cf = (ConnectionFactory) ic.lookup("myeis/ConnectionFactory");
            MyEisInteractionSpec iSpec = (MyEisInteractionSpec)ic.lookup("myeis/InteractionSpec");
            iSpec.setOperationName("CountCustomers");
    
            con = cf.getConnection();
            Interaction ix = con.createInteraction();
            RecordFactory rf = cf.getRecordFactory();
            IndexedRecord iRec = rf.createIndexedRecord("InputRecord");
            IndexedRecord rec = (IndexedRecord)ix.execute(iSpec, iRec);
    
            int count = 0;
            Iterator iterator = rec.iterator();
            if(iterator.hasNext()) {
                if(iterator.hasNext()) {
                    Integer result = (Integer)iterator.next();
                    count = result.intValue();
                }
            }
            return count;
        }
        catch (NamingException ex) {
            throw new MyEisException(ex.toString());
        }
        catch (ResourceException ex) {
            throw new MyEisException(ex.toString());
        }
        finally {
            try {con.close();} catch (Exception ex){}
        }
    }
}

class MyEisInteractionSpec implements InteractionSpec
{
    public void setOperationName(String name) {}
}

class MyEisException extends Exception
{
    public MyEisException(String s) {super(s);}
}
